/*********************************************************************************************/
/*======================= /  ATmega168============================*/
/*********************************************************************************************/
/* 1.4
   : WinAVR-20060125
  Make: Name=muzshkat,Level=2,Debug=VMLab,Programmer=ponyser ( usbasp),Port=com1
        MCU=atmega168

    ATmega168:
            BODLEVEL 2..0 = 110 -  BOD ,   U<1,8
               1 :
            CKDIV = 1 -  
            CKSEL3..0 = 1010 -      0,9..3 
            SUT10 = 10 -  , BOD 
          ( CKSEL3..0 = 1011 -      0,9..3 
            SUT10=01 -  ,  BOD )

              RC-
           (CKSEL3..0 = 0010 -    RC-, 8
            SUT10=10 -   ,   
            CKDIV = 0 -  )

  "0"-  !!!

   1  + 2 . =12..22

   Sound+ PORTB.1                       // - .15  (OC1A)
   Sound- PORTB.2                       // - .16  (OC1B)
*/
//
#include <avr/io.h>                          //  
#include <avr/interrupt.h>                   //   
#include <avr/pgmspace.h>                    //  
#include <avr/sleep.h>                       //   
#include <avr/eeprom.h>                      //    EEPROM
#include <melodii.h>                         //    
//
//:
#define Butt1 PD2                            //   - .4 
#define Butt2 PD3                            //  - .5 
#define Power PB0                            //  - .14 
#define Light PB3                            //  - .17 (OC2A) 
//
/*----  ----*/
volatile unsigned char Play=1;               //1-, 0-
volatile unsigned char Song=0;               //  
volatile unsigned char melody_index=0;       //  
//volatile unsigned char prer=0;               // 
//
/*----  ----*/
void tayms (unsigned char t);                //  
//
/*----    0 (   )----*/
/*
ISR (INT0_vect)                              //   
{ tayms(40);                                 //  
  if (bit_is_clear(PIND, Butt1))             //    
  { Play=1;                                  // 
    melody_index=0;                          //    
    TCCR1A=0b10100000;                       //  OC1A  OC1B  
    tayms(40);                               //
    prer=1;                                  // 
  }
}
//
/*----    1 (   )----*/
ISR (INT1_vect)                              //   
{ tayms(40);                                 //  
  if (bit_is_clear(PIND, Butt2))             //    
  { if (Song==0) Song=Qmel;                  // 
    else Song--;                             //  
    melody_index=0;                          //    
    Play=1;                                  // 
    eeprom_write_byte(511, Song);            //     EEPROM   511
    TCCR1A=0b10100000;                       //  OC1A  OC1B  
  }
}
//
/*----- -----*/
int main (void)
{
// 
// B
  PORTB=0b11111001;                //PB7..PB4-. ..,PB0=1(..),PB3=1(..)
  DDRB=0b000011111;                //PB3..PB0 - 
// D
  PORTD=0b11111111; DDRD=0b00000000;//PD7..PD0 -   ..
// C
  PORTC=0b01111111; DDRC=0x00;     //PC6..PC0 -   ..
//
  ACSR|=_BV(ACD);                  //ACSR(ACD)=1 -   
//  
  EICRA=0b00001010;                //     INT1,INT0
  EIFR=0b00000011;                 //  INTF1, INTF0  
  EIMSK=0b00000010;                //INT1=1,INT0=0 -    INT1
//
  unsigned char ton=0;             //  (T=2*(256-XXX)/125000, F=1/T)
  unsigned char lng=0;             //  
//  
  Song=eeprom_read_byte(511);      //  EEPROM      511
  Song++;                          //  
  if (Song>=Qmel) Song=0;          // 
  eeprom_write_byte(511, Song);    //     EEPROM   511
//  1
  TCNT1=0;                         // ..1
  OCR1AL=Pausa;                    // 
  TCCR1B=0b00001010;               // ..1   CTC1(WGM12)=1 -   ,
                                   //F=Fclc/8=125
//   (F=976,5625/(162+1)/2=2,9955 )  8..10    ,  !!!
  TCCR2A=0b01000010;               //  OC2A  
  OCR2A=162;
  TCCR2B=0b00000111;               // ..2   Fclk/1024=1/1024=976,5625
//
  sei();                           //  
  while(1)                         // 
  { if (Play==0)                   //  
    { TCCR1A=0b10100000;           //  OC1A  OC1B    ..
      OCR1AL=1;                    // OCR1AL   OCR  8 
      TCNT1=0;                     // ..1
      tayms(0);                    // 11 
      TCCR1B=0b00000000;           // ..1
      TCCR1A=0b00000000;           // OC1A  OC1B  ..1
      TCCR2A=0b00000000;           // OC2A  ..2
      TCCR2B=0b00000000;           // ..2
      melody_index=0;              //  
      PORTB=PORTB&0b11111000;      //  
      PORTB|=_BV(Light);           // 
      tayms(50);                   //     
      PORTB&=~_BV(Light);          // 
      set_sleep_mode(SLEEP_MODE_PWR_DOWN);//   Power Down
      sleep_mode();                //    (  
                                   //     Power)
    }
    if (melody_index<pgm_read_byte(massqmel+Song)) //       
    { switch (Song)                // 
      { case 0:                    //""
             ton=pgm_read_byte(&Siren[melody_index][0]);//  
             lng=pgm_read_byte(&Siren[melody_index][1]);// 
             break;
        case 1:                    //"  (.)"
             ton=pgm_read_byte(&Moment[melody_index][0]);//  
             lng=pgm_read_byte(&Moment[melody_index][1]);// 
             break;
        case 2:                    //" "
             ton=pgm_read_byte(&Roman[melody_index][0]);//  
             lng=pgm_read_byte(&Roman[melody_index][1]);// 
             break;
        case 3:                    //" "
             ton=pgm_read_byte(&Bank[melody_index][0]);//  
             lng=pgm_read_byte(&Bank[melody_index][1]);// 
             break;
        case 4:                    //" "
             ton=pgm_read_byte(&Djen[melody_index][0]);//  
             lng=pgm_read_byte(&Djen[melody_index][1]);// 
             break;
        case 5:                    //" "
             ton=pgm_read_byte(&Platoch[melody_index][0]);//  
             lng=pgm_read_byte(&Platoch[melody_index][1]);// 
             break;
        case 6:                    //""
             ton=pgm_read_byte(&Kumpars[melody_index][0]);//  
             lng=pgm_read_byte(&Kumpars[melody_index][1]);// 
             break;
        case 7:                    //" "
             ton=pgm_read_byte(&Slav[melody_index][0]);//  
             lng=pgm_read_byte(&Slav[melody_index][1]);// 
             break;
        case 8:                    //""
             ton=pgm_read_byte(&Valenki[melody_index][0]);//  
             lng=pgm_read_byte(&Valenki[melody_index][1]);// 
             break;
        case 9:                    //" "
             ton=pgm_read_byte(&Garmon[melody_index][0]);//  
             lng=pgm_read_byte(&Garmon[melody_index][1]);// 
             break;
        case 10:                   //",  "
             ton=pgm_read_byte(&Kalina[melody_index][0]);//  
             lng=pgm_read_byte(&Kalina[melody_index][1]);// 
             break;
        case 11:                   //" "
             ton=pgm_read_byte(&Kamysh[melody_index][0]);//  
             lng=pgm_read_byte(&Kamysh[melody_index][1]);// 
             break;
        case 12:                   //""
             ton=pgm_read_byte(&Katysha[melody_index][0]);//  
             lng=pgm_read_byte(&Katysha[melody_index][1]);// 
             break;
        case 13:                   //" "
             ton=pgm_read_byte(&Kazachka[melody_index][0]);//  
             lng=pgm_read_byte(&Kazachka[melody_index][1]);// 
             break;
        case 14:                   //" "
             ton=pgm_read_byte(&Osen_Son[melody_index][0]);//  
             lng=pgm_read_byte(&Osen_Son[melody_index][1]);// 
             break;
        case 15:                   //" "
             ton=pgm_read_byte(&Dunay[melody_index][0]);//  
             lng=pgm_read_byte(&Dunay[melody_index][1]);// 
             break;
        case 16:                   //"  "
             ton=pgm_read_byte(&Manych[melody_index][0]);//  
             lng=pgm_read_byte(&Manych[melody_index][1]);// 
             break;
        case 17:                   //" "
             ton=pgm_read_byte(&Koster[melody_index][0]);//  
             lng=pgm_read_byte(&Koster[melody_index][1]);// 
             break;
        case 18:                   //"  "
             ton=pgm_read_byte(&More[melody_index][0]);//  
             lng=pgm_read_byte(&More[melody_index][1]);// 
             break;
        case 19:                   //""
             ton=pgm_read_byte(&Polonez[melody_index][0]);//  
             lng=pgm_read_byte(&Polonez[melody_index][1]);// 
             break;
        case 20:                   //""
             ton=pgm_read_byte(&Yablochko[melody_index][0]);//  
             lng=pgm_read_byte(&Yablochko[melody_index][1]);// 
             break;
        case 21:                   //""
             ton=pgm_read_byte(&Cyganochka[melody_index][0]);//  
             lng=pgm_read_byte(&Cyganochka[melody_index][1]);// 
             break;
        case 22:                   //" "
             ton=pgm_read_byte(&Golub_Vagon[melody_index][0]);//  
             lng=pgm_read_byte(&Golub_Vagon[melody_index][1]);// 
             break;
        case 23:                   //" "
             ton=pgm_read_byte(&Star_Klen[melody_index][0]);//  
             lng=pgm_read_byte(&Star_Klen[melody_index][1]);// 
             break;
        case 24:                   //" -   "
             ton=pgm_read_byte(&Ktoto[melody_index][0]);//  
             lng=pgm_read_byte(&Ktoto[melody_index][1]); // 
             break;
        case 25:                   //"   "
             ton=pgm_read_byte(&Luchshe[melody_index][0]);//  
             lng=pgm_read_byte(&Luchshe[melody_index][1]); // 
             break;
        case 26:                   //""
             ton=pgm_read_byte(&Murka[melody_index][0]);//  
             lng=pgm_read_byte(&Murka[melody_index][1]);// 
             break;
        case 27:                   //", "
             ton=pgm_read_byte(&Parovoz[melody_index][0]);//  
             lng=pgm_read_byte(&Parovoz[melody_index][1]);// 
             break;
        case 28:                   //"  ?"
             ton=pgm_read_byte(&Vinovata[melody_index][0]);//  
             lng=pgm_read_byte(&Vinovata[melody_index][1]); // 
             break;
        case 29:                   //" "
             ton=pgm_read_byte(&Ryabina[melody_index][0]);//  
             lng=pgm_read_byte(&Ryabina[melody_index][1]); // 
             break;
        case 30:                   //" -"
             ton=pgm_read_byte(&St_dor[melody_index][0]);//  
             lng=pgm_read_byte(&St_dor[melody_index][1]);// 
             break;
        case 31:                   //""
             ton=pgm_read_byte(&Tumbalalay[melody_index][0]);//  
             lng=pgm_read_byte(&Tumbalalay[melody_index][1]);// 
             break;
        case 32:                   //" "
             ton=pgm_read_byte(&Kadril[melody_index][0]);//  
             lng=pgm_read_byte(&Kadril[melody_index][1]);// 
             break;
        case 33:                   //" (  " ")"
             ton=pgm_read_byte(&Stradanie[melody_index][0]);//  
             lng=pgm_read_byte(&Stradanie[melody_index][1]);// 
             break;
        case 34:                   //"Alouette (  "  ")"
             ton=pgm_read_byte(&Alouette[melody_index][0]);//  
             lng=pgm_read_byte(&Alouette[melody_index][1]);// 
             break;
        case 35:                   //"  (  "")"
             ton=pgm_read_byte(&Cuygan[melody_index][0]);//  
             lng=pgm_read_byte(&Cuygan[melody_index][1]);// 
             break;
        case 36:                   //"Man Of Mystery (Shadows)"
             ton=pgm_read_byte(&Shadows[melody_index][0]);//  
             lng=pgm_read_byte(&Shadows[melody_index][1]);// 
             break;
        case 37:                   //" "
             ton=pgm_read_byte(&Samovar[melody_index][0]);//  
             lng=pgm_read_byte(&Samovar[melody_index][1]);// 
             break;
        case 38:                   //""
             ton=pgm_read_byte(&Shalandi[melody_index][0]);//  
             lng=pgm_read_byte(&Shalandi[melody_index][1]);// 
             break;
        case 39:                   //"    "
             ton=pgm_read_byte(&Metelica[melody_index][0]);//  
             lng=pgm_read_byte(&Metelica[melody_index][1]);// 
             break;
        case 40:                   //" "
             ton=pgm_read_byte(&Podmvech[melody_index][0]);//  
             lng=pgm_read_byte(&Podmvech[melody_index][1]);// 
             break;
        case 41:                   //"   "
             ton=pgm_read_byte(&Pidman[melody_index][0]);//  
             lng=pgm_read_byte(&Pidman[melody_index][1]);// 
             break;
        case 42:                   //" "
             ton=pgm_read_byte(&Romashki[melody_index][0]);//  
             lng=pgm_read_byte(&Romashki[melody_index][1]);// 
             break;
        case 43:                   //"    "
             ton=pgm_read_byte(&Cvetochk[melody_index][0]);//  
             lng=pgm_read_byte(&Cvetochk[melody_index][1]);// 
             break;
        case 44:                   //"  "
             ton=eeprom_read_byte(&Milmoy[melody_index][0]);//  
             lng=eeprom_read_byte(&Milmoy[melody_index][1]);// 
             break;
        case 45:                   //"  "
             ton=pgm_read_byte(&Privolye[melody_index][0]);//  
             lng=pgm_read_byte(&Privolye[melody_index][1]);// 
             break;
        case 46:                   //"  "
             ton=pgm_read_byte(&Vuynaul[melody_index][0]);//  
             lng=pgm_read_byte(&Vuynaul[melody_index][1]);// 
             break;
        case 47:                   //""
             ton=pgm_read_byte(&Zolushka[melody_index][0]);//  
             lng=pgm_read_byte(&Zolushka[melody_index][1]);// 
             break;
        case 48:                   //" , "
             ton=pgm_read_byte(&Berezyu[melody_index][0]);//  
             lng=pgm_read_byte(&Berezyu[melody_index][1]);// 
             break;
        case 49:                   //"  "
             ton=eeprom_read_byte(&Polustan[melody_index][0]);//  
             lng=eeprom_read_byte(&Polustan[melody_index][1]);// 
             break;
        case 50:                   //"   "
             ton=pgm_read_byte(&Yanemogu[melody_index][0]);//  
             lng=pgm_read_byte(&Yanemogu[melody_index][1]);// 
             break;
        case 51:                   //"    "
             ton=pgm_read_byte(&Druzya[melody_index][0]);//  
             lng=pgm_read_byte(&Druzya[melody_index][1]);// 
             break;
        case 52:                   //"  "
             ton=pgm_read_byte(&Kr_Shapk[melody_index][0]);//  
             lng=pgm_read_byte(&Kr_Shapk[melody_index][1]);// 
             break;
        case 53:                   //"  "
             ton=pgm_read_byte(&Utyat[melody_index][0]);//  
             lng=pgm_read_byte(&Utyat[melody_index][1]);// 
             break;
        case 54:                   //"   "
             ton=pgm_read_byte(&Ubabushk[melody_index][0]);//  
             lng=pgm_read_byte(&Ubabushk[melody_index][1]);// 
             break;
        case 55:                   //"   "
             ton=eeprom_read_byte(&Elochka[melody_index][0]);//  
             lng=eeprom_read_byte(&Elochka[melody_index][1]);// 
             break;
        case 56:                   //"  "
             ton=pgm_read_byte(&TriBelKn[melody_index][0]);//  
             lng=pgm_read_byte(&TriBelKn[melody_index][1]);// 
             break;
        case 57:                   //"  "
             ton=pgm_read_byte(&Vlesu[melody_index][0]);//  
             lng=pgm_read_byte(&Vlesu[melody_index][1]);// 
             break;
        case 58:                   //"  "
             ton=pgm_read_byte(&Polyan[melody_index][0]);//  
             lng=pgm_read_byte(&Polyan[melody_index][1]);// 
             break;
        case 59:                   //" "
             ton=pgm_read_byte(&BelTanec[melody_index][0]);//  
             lng=pgm_read_byte(&BelTanec[melody_index][1]);// 
             break;
        case 60:                   //"    "
             ton=pgm_read_byte(&Bremensk[melody_index][0]);//  
             lng=pgm_read_byte(&Bremensk[melody_index][1]);// 
             break;
        case 61:                   //"   "
             ton=pgm_read_byte(&Klen_Op[melody_index][0]);//  
             lng=pgm_read_byte(&Klen_Op[melody_index][1]);// 
             break;
        case 62:                   //", , "
             ton=pgm_read_byte(&Moroz[melody_index][0]);//  
             lng=pgm_read_byte(&Moroz[melody_index][1]);// 
             break;
        case 63:                   //""
             ton=pgm_read_byte(&Oblaka[melody_index][0]);//  
             lng=pgm_read_byte(&Oblaka[melody_index][1]);// 
             break;
        case 64:                   //"  "
             ton=pgm_read_byte(&Keyptaun[melody_index][0]);//  
             lng=pgm_read_byte(&Keyptaun[melody_index][1]);// 
             break;
        case 65:                   //""
             ton=pgm_read_byte(&Korobeyn[melody_index][0]);//  
             lng=pgm_read_byte(&Korobeyn[melody_index][1]);// 
             break;
        case 66:                   //" "
             ton=pgm_read_byte(&Kr_Otec[melody_index][0]);//  
             lng=pgm_read_byte(&Kr_Otec[melody_index][1]);// 
             break;
        case 67:                   //"    "
             ton=pgm_read_byte(&Vmeste[melody_index][0]);//  
             lng=pgm_read_byte(&Vmeste[melody_index][1]);// 
             break;
        case 68:                   //"  ()"
             ton=pgm_read_byte(&Der_Dur[melody_index][0]);//  
             lng=pgm_read_byte(&Der_Dur[melody_index][1]);// 
             break;
        case 69:                   //"-"
             ton=eeprom_read_byte(&Rio_Rita[melody_index][0]);//  
             lng=eeprom_read_byte(&Rio_Rita[melody_index][1]);// 
             break;
        case 70:                   //"  "
             ton=pgm_read_byte(&Pesn_KrG[melody_index][0]);//  
             lng=pgm_read_byte(&Pesn_KrG[melody_index][1]);// 
             break;
      }
    }
    else Play=0;                   // -  
    if (ton==Pausa)                // 
    { TCCR1A=0b10100000;           //  OC1A  OC1B  
    }
    else
    { //  
      TCNT1=0;                     // ..1
      if (ton<30)                  //  
      { OCR1A=pgm_read_word(mal_okt+ton); // 
      }
/*
      { switch (ton)          // 
        { case 0: OCR1A=267;break; //  ( )  
          case 1: OCR1A=283;break; //  
          case 2: OCR1A=301;break; //  ( )  
          case 3: OCR1A=318;break; //  
          case 4: OCR1A=337;break; //   
          case 5: OCR1A=357;break; //  
          case 6: OCR1A=378;break; //  
          case 7: OCR1A=401;break; //  ( )  
          case 8: OCR1A=422;break; //  
          case 9: OCR1A=450;break; //  ( )  
          case 10: OCR1A=477;break;//  
          case 11: OCR1A=505;break;//  
          case 12: OCR1A=535;break;//   
        }
      }
*/
      else                         //,      
      { OCR1AH=0;                  //    
        OCR1AL=ton;                //  
      }
      TCCR1B=0b00001010;           // ..1   CTC1(WGM12)=1 -   ,
                                   //F=Fclc/8=125
      TCCR1A=0b01010000;           // OC1A  OC1B   ..1 ( )
      TCCR1C|=_BV(FOC1B);          //... OC1B   .
    }
    while(lng>0)                   //     
    { tayms(31);                   // 31 
      lng--;
    }
    melody_index++;                //   
    //  
    TCCR1A=0b10100000;             //  OC1A  OC1B  
    tayms(5);                      //   (   40 )
  }
}
//
/*----    (1...255)  Fclk=1----*/
void tayms (unsigned char t)
{ unsigned int t1;
  while (t!=0)
  { t1=997;
    while(--t1>0);
    t--;
  }
  return;                         // t=0  = 11 
}
//
/*
Program:    16380 bytes (100.0% Full) (16384 bytes .  ATmega168)
(.text + .data + .bootloader)

Data:          4 bytes (0.4% Full) (1024 bytes .)
(.data + .bss + .noinit)

EEPROM:      511 bytes (99.8% Full) (512 bytes .)
(.eeprom)
*/
